import { Router } from './router/router.js';
interface AppOptions {
    router?: Router;
    error?: (err: Error) => Response | void;
}
/**
 * @example
 * const app = new App()
 * app.router.get('/', ctx => ctx.text('/'))
 *
 * Server.listen(app.fetch, {transport: 'http', port: 50000})
 *
 * */
export declare class App {
    #private;
    readonly router: Router;
    readonly fetch: OmitThisParameter<(request: Request) => Promise<Response>>;
    constructor(options?: AppOptions);
}
export {};
